#ifndef EVAL_H
#define EVAL_H

#include "util/interval.h"
#include "util/region.h"
#include "util/switches.h"

// Forward declarations
struct PackedTree_;


/*  eval_f
 *
 *  Evaluates a math expression at a given floating-point position.
 *  Results are stored in n->head->results.f
 */
float  eval_f(struct PackedTree_* n, const float x, const float y, const float z);


/*  eval_i
 *
 *  Evaluates a math expression over an interval region.
 *  Results are stored in n->head->results.i
 */
Interval  eval_i(struct PackedTree_* n, const Interval X,
                                        const Interval Y,
                                        const Interval Z);

/*  eval_r
 *
 *  Evaluates a math expression over a set of many floating-point values
 *  Results are stored in the array n->head->results.r
 */
float*  eval_r(struct PackedTree_* n, const Region r);

#endif